import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
    
public class TransformXML {
  public static void main(String args []) {
    try {
      // Create transformer factory
      TransformerFactory factory = TransformerFactory.newInstance();
    
      // Use the factory to create a template containing the xsl file
      Templates template = factory.newTemplates(new StreamSource(
          new FileInputStream(args[1])));
    
      // Use the template to create a transformer
      Transformer xformer = template.newTransformer();
      // Indent output
      xformer.setOutputProperty("indent","yes");

      // Set global parameters in XSL file
      for (int i=2; i<args.length; i++) {
        int ii = args[i].indexOf("=");
        String pname = args[i].substring(0,ii);
        String pvalue = args[i].substring(ii+1);
        xformer.setParameter(pname,pvalue);
      }
    
      // Prepare the input and output files
      Source source = new StreamSource(new FileInputStream(args[0]));
      Result result = new StreamResult(new PrintStream(System.out));
    
      // Apply the xsl file to the source file send result to System.out
      // to the output file
      xformer.transform(source, result);
    } catch (FileNotFoundException e) {
        System.out.println("File not found exception");
    } catch (TransformerConfigurationException e) {
        System.out.println("An error occurred in the XSL file");
    } catch (TransformerException e) {
        System.out.println("An error occurred while applying the XSL file");
    }
  }
}
